## ros-humble-moveit-servo 2.5.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22)
project(moveit_servo)

# C++ Libraries #################################################

# Core C++ library for calculations and collision checking.
# Provides interface used by the component node.
set(SERVO_LIB_NAME moveit_servo_lib)
# C++ library containing the parameters initialization
# - This is intended to use with the component node when you
# -   need to read the parameters loaded into servo in a separate
# -   node.
set(SERVO_PARAM_LIB_NAME ${SERVO_LIB_NAME}_parameters)

# Pose Tracking
set(POSE_TRACKING pose_tracking)

# Component Nodes (Shared libraries) ############################
set(SERVO_COMPONENT_NODE servo_node)
set(SERVO_CONTROLLER_INPUT servo_controller_input)

# Executable Nodes ##############################################
set(SERVO_NODE_MAIN_NAME servo_node_main)
set(POSE_TRACKING_DEMO_NAME servo_pose_tracking_demo)
set(FAKE_SERVO_CMDS_NAME fake_command_publisher)

#################################################################

# Common cmake code applied to all moveit packages
find_package(moveit_common REQUIRED)
moveit_package()

set(THIS_PACKAGE_INCLUDE_DEPENDS
  control_msgs
  control_toolbox
  geometry_msgs
  moveit_core
  moveit_msgs
  moveit_ros_planning
  pluginlib
  rclcpp
  rclcpp_components
  sensor_msgs
  std_msgs
  std_srvs
  tf2_eigen
  trajectory_msgs
)

find_package(ament_cmake REQUIRED)
find_package(eigen3_cmake_module REQUIRED)
find_package(Eigen3 REQUIRED)
foreach(Dependency IN ITEMS ${THIS_PACKAGE_INCLUDE_DEPENDS})
  find_package(${Dependency} REQUIRED)
endforeach()

include_directories(
  include
)

###################
## C++ Libraries ##
###################

# This library provides a way of loading parameters for servo
add_library(${SERVO_PARAM_LIB_NAME} SHARED
  src/servo_parameters.cpp
  src/parameter_descriptor_builder.cpp
)
set_target_properties(${SERVO_PARAM_LIB_NAME} PROPERTIES VERSION "${${PROJECT_NAME}_VERSION}")
ament_target_dependencies(${SERVO_PARAM_LIB_NAME} ${THIS_PACKAGE_INCLUDE_DEPENDS})

# This library provides a C++ interface for sending realtime twist or joint commands to a robot
add_library(${SERVO_LIB_NAME} SHARED
  # These files are used to produce differential motion
  src/collision_check.cpp
  src/enforce_limits.cpp
  src/servo.cpp
  src/servo_calcs.cpp
  src/utilities.cpp
)
set_target_properties(${SERVO_LIB_NAME} PROPERTIES VERSION "${${PROJECT_NAME}_VERSION}")
ament_target_dependencies(${SERVO_LIB_NAME} ${THIS_PACKAGE_INCLUDE_DEPENDS})
target_link_libraries(${SERVO_LIB_NAME} ${SERVO_PARAM_LIB_NAME})

add_library(${POSE_TRACKING} SHARED src/pose_tracking.cpp)
ament_target_dependencies(${POSE_TRACKING} ${THIS_PACKAGE_INCLUDE_DEPENDS})
target_link_libraries(${POSE_TRACKING} ${SERVO_LIB_NAME})

#####################
## Component Nodes ##
#####################

# Add and export library to run as a ROS node component, and receive commands via topics
add_library(${SERVO_COMPONENT_NODE} SHARED src/servo_node.cpp)
ament_target_dependencies(${SERVO_COMPONENT_NODE} ${THIS_PACKAGE_INCLUDE_DEPENDS})
target_link_libraries(${SERVO_COMPONENT_NODE} ${SERVO_LIB_NAME})
rclcpp_components_register_nodes(${SERVO_COMPONENT_NODE} "moveit_servo::ServoNode")

# Add executable for using a controller
add_library(${SERVO_CONTROLLER_INPUT} SHARED src/teleop_demo/joystick_servo_example.cpp)
ament_target_dependencies(${SERVO_CONTROLLER_INPUT} ${THIS_PACKAGE_INCLUDE_DEPENDS})
rclcpp_components_register_nodes(${SERVO_CONTROLLER_INPUT} "moveit_servo::JoyToServoPub")

######################
## Executable Nodes ##
######################

# An executable node for the servo server
add_executable(${SERVO_NODE_MAIN_NAME} src/servo_node_main.cpp)
target_link_libraries(${SERVO_NODE_MAIN_NAME} ${SERVO_COMPONENT_NODE})
ament_target_dependencies(${SERVO_NODE_MAIN_NAME} ${THIS_PACKAGE_INCLUDE_DEPENDS})

# An example of pose tracking
add_executable(${POSE_TRACKING_DEMO_NAME} src/cpp_interface_demo/pose_tracking_demo.cpp)
target_link_libraries(${POSE_TRACKING_DEMO_NAME} ${POSE_TRACKING})
ament_target_dependencies(${POSE_TRACKING_DEMO_NAME} ${THIS_PACKAGE_INCLUDE_DEPENDS})

# Add executable to publish fake servo commands for testing/demo purposes
add_executable(${FAKE_SERVO_CMDS_NAME} test/publish_fake_jog_commands.cpp)
ament_target_dependencies(${FAKE_SERVO_CMDS_NAME}
  rclcpp
  geometry_msgs
  std_srvs
)

#############
## Install ##
#############

# Install Libraries
install(
  TARGETS
    ${SERVO_LIB_NAME}
    ${SERVO_LIB_NAME}_parameters
    ${POSE_TRACKING}
    ${SERVO_COMPONENT_NODE}
    ${SERVO_CONTROLLER_INPUT}
  EXPORT export_${PROJECT_NAME}
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
  RUNTIME DESTINATION bin
  INCLUDES DESTINATION include
)

# Install Binaries
install(
  TARGETS
    ${SERVO_NODE_MAIN_NAME}
    ${CPP_DEMO_NAME}
    ${POSE_TRACKING_DEMO_NAME}
    ${FAKE_SERVO_CMDS_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION lib/${PROJECT_NAME}
)

# Install include, launch, config directories
install(DIRECTORY include/ DESTINATION include)
install(DIRECTORY launch DESTINATION share/${PROJECT_NAME})
install(DIRECTORY config DESTINATION share/${PROJECT_NAME})

ament_export_targets(export_${PROJECT_NAME} HAS_LIBRARY_TARGET)
ament_export_dependencies(${THIS_PACKAGE_INCLUDE_DEPENDS})

#############
## TESTING ##
#############

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(ros_testing REQUIRED)
  find_package(Boost REQUIRED COMPONENTS filesystem)

  # These don't pass yet, disable them for now
  set(ament_cmake_copyright_FOUND TRUE)
  set(ament_cmake_cpplint_FOUND TRUE)
  set(ament_cmake_flake8_FOUND TRUE)
  set(ament_cmake_uncrustify_FOUND TRUE)

  # Run all lint tests in package.xml except those listed above
  ament_lint_auto_find_test_dependencies()

  # Servo integration launch test
  ament_add_gtest_executable(test_servo_integration
      test/test_servo_interface.cpp
      test/servo_launch_test_common.hpp
  )
  target_link_libraries(test_servo_integration ${SERVO_PARAM_LIB_NAME})
  ament_target_dependencies(test_servo_integration ${THIS_PACKAGE_INCLUDE_DEPENDS})
  add_ros_test(test/launch/test_servo_integration.test.py TIMEOUT 120 ARGS "test_binary_dir:=${CMAKE_CURRENT_BINARY_DIR}")

  # Servo collision checking integration test
  ament_add_gtest_executable(test_servo_collision
        test/test_servo_collision.cpp
        test/servo_launch_test_common.hpp
  )
  target_link_libraries(test_servo_collision ${SERVO_PARAM_LIB_NAME})
  ament_target_dependencies(test_servo_collision ${THIS_PACKAGE_INCLUDE_DEPENDS})
  add_ros_test(test/launch/test_servo_collision.test.py TIMEOUT 120 ARGS "test_binary_dir:=${CMAKE_CURRENT_BINARY_DIR}")

  # pose_tracking
  ament_add_gtest_executable(test_servo_pose_tracking
        test/pose_tracking_test.cpp
  )
  ament_target_dependencies(test_servo_pose_tracking ${THIS_PACKAGE_INCLUDE_DEPENDS})
  target_link_libraries(test_servo_pose_tracking ${POSE_TRACKING})
  add_ros_test(test/launch/test_servo_pose_tracking.test.py TIMEOUT 120 ARGS "test_binary_dir:=${CMAKE_CURRENT_BINARY_DIR}")

  # Unit tests
  ament_add_gtest(servo_calcs_unit_tests
    test/servo_calcs_unit_tests.cpp
  )
  target_link_libraries(servo_calcs_unit_tests ${SERVO_LIB_NAME})

endif()

ament_package()

=== debian/changelog ===
ros-humble-moveit-servo (2.5.5-1jammy) jammy; urgency=high

  * Replaced numbers with SystemDefaultsQos() (#2271 <https://github.com/ros-planning/moveit2/issues/2271>) (#2277 <https://github.com/ros-planning/moveit2/issues/2277>)
    (cherry picked from commit 5506dd516a91bc145e462b493668ef8623d43521)
    Co-authored-by: Shobuj Paul <mailto:72087882+Shobuj-Paul@users.noreply.github.com>
  * [Servo] CI simplification (backport #1556 <https://github.com/ros-planning/moveit2/issues/1556>) (#1980 <https://github.com/ros-planning/moveit2/issues/1980>)
  * Fix clang compiler warnings (backport of #1712 <https://github.com/ros-planning/moveit2/issues/1712>) (#1896 <https://github.com/ros-planning/moveit2/issues/1896>)
    - Fix warning: definition of implicit copy assignment operator is deprecated
    - Fix warning: expression with side effects will be evaluated
    - Fix warning: passing by value
    - Enable -Werror
    - Fix -Wdelete-non-abstract-non-virtual-dtor
    - Fix more clang warnings
    - Modernize gtest: TYPED_TEST_CASE -> TYPED_TEST_SUITE
    - Fix GoogleTestVerification.UninstantiatedTypeParameterizedTestSuite
    - Add default copy/move constructors/assignment operators
    As a user-declared destructor deletes any implicitly-defined move constructor/assignment operator,
    we need to declared them manually. This in turn requires to declare the copy constructor/assignment as well.
    - Explicitly declare overrides
    - Add default constructors as they are not implicitly declared anymore
    - Declare selected classes as final
    - Add noexcept specifier to constructors
    - Fixup gmock/gtest warnings
  * Cleanup msg includes: Use C++ instead of C header (backport #1844 <https://github.com/ros-planning/moveit2/issues/1844>)
    * Cleanup msg includes: Use C++ instead of C header
    * Remove obsolete include: moveit_msgs/srv/execute_known_trajectory.hpp
  * Use <> for non-local headers (#1765 <https://github.com/ros-planning/moveit2/issues/1765>)
    Unless a header lives in the same or a child directory of the file
    including it, it's recommended to use <> for the #include statement.
    For more information, see the C++ Core Guidelines item SF.12
    https://isocpp.github.io/CppCoreGuidelines/CppCoreGuidelines#sf12-prefer-the-quoted-form-of-include-for-files-relative-to-the-including-file-and-the-angle-bracket-form-everywhere-else
    (cherry picked from commit 7a1f2a101f9aeb8557e8a31656bbe1a6d53b430e)
  * Re-enable clang-tidy check performance-unnecessary-value-param (backport #1703 <https://github.com/ros-planning/moveit2/issues/1703>)
    * Re-enable clang-tidy check performance-unnecessary-value-param (#1703 <https://github.com/ros-planning/moveit2/issues/1703>)
    * Fix clang-tidy issues (#1706 <https://github.com/ros-planning/moveit2/issues/1706>)
    Co-authored-by: Henning Kayser <mailto:henningkayser@picknik.ai>
    Co-authored-by: Robert Haschke <mailto:rhaschke@users.noreply.github.com>
  * Contributors: AndyZe, Chris Thrasher, Robert Haschke, mergify[bot]

 -- Blake Anderson <blakeanderson@utexas.edu>  Sat, 09 Sep 2023 22:00:00 -0000

ros-humble-moveit-servo (2.5.4-1jammy) jammy; urgency=high

  * [Servo] Remove the option for "stop distance"-based collision checking (#1574 <https://github.com/ros-planning/moveit2/issues/1574>) (#1663 <https://github.com/ros-planning/moveit2/issues/1663>)
    (cherry picked from commit e96004702bbd338a08340eab0985fd04c74968fa)
    Co-authored-by: AndyZe <mailto:zelenak@picknik.ai>
  * [Servo] Use a WallRate so the clock is monotonically increasing (#1543 <https://github.com/ros-planning/moveit2/issues/1543>) (#1658 <https://github.com/ros-planning/moveit2/issues/1658>)
    (cherry picked from commit c134d89710e831ae58a66e53d87a78b44b0b307c)
    Co-authored-by: AndyZe <mailto:zelenak@picknik.ai>
  * Disable flaky test_servo_singularity + test_rdf_integration (#1530 <https://github.com/ros-planning/moveit2/issues/1530>) (#1654 <https://github.com/ros-planning/moveit2/issues/1654>)
    (cherry picked from commit f7655df7a439069565efa0de73c08e9d1dd45dde)
    Co-authored-by: Sebastian Jahr <mailto:sebastian.jahr@picknik.ai>
  * Enforce singularity threshold when moving away from a singularity (#620 <https://github.com/ros-planning/moveit2/issues/620>) (#1649 <https://github.com/ros-planning/moveit2/issues/1649>)
  * Improve CMake usage (#1550 <https://github.com/ros-planning/moveit2/issues/1550>) (#1555 <https://github.com/ros-planning/moveit2/issues/1555>)
    Co-authored-by: Sebastian Jahr <mailto:sebastian.jahr@picknik.ai>
  * Remove __has_include statements (#1481 <https://github.com/ros-planning/moveit2/issues/1481>) (#1483 <https://github.com/ros-planning/moveit2/issues/1483>)
  * Contributors: mergify[bot]

 -- Blake Anderson <blakeanderson@utexas.edu>  Thu, 03 Nov 2022 23:00:00 -0000

ros-humble-moveit-servo (2.5.3-1jammy) jammy; urgency=high

  * Use kinematics plugin instead of inverse Jacobian for servo IK (#1434 <https://github.com/ros-planning/moveit2/issues/1434>)
  * Contributors: Wyatt Rees

 -- Blake Anderson <blakeanderson@utexas.edu>  Wed, 27 Jul 2022 22:00:00 -0000

ros-humble-moveit-servo (2.5.2-1jammy) jammy; urgency=high

  * Merge remote-tracking branch 'origin/main' into feature/msa
  * Removing more boost usage (#1372 <https://github.com/ros-planning/moveit2/issues/1372>)
  * Merge remote-tracking branch 'upstream/main' into feature/msa
  * Removing some boost usage (#1331 <https://github.com/ros-planning/moveit2/issues/1331>)
  * Remove unnecessary rclcpp.hpp includes (#1333 <https://github.com/ros-planning/moveit2/issues/1333>)
  * Update Servo integration tests (#1336 <https://github.com/ros-planning/moveit2/issues/1336>)
  * Minor cleanup of Servo CMakeLists (#1345 <https://github.com/ros-planning/moveit2/issues/1345>)
  * Contributors: AndyZe, David V. Lu, Henry Moore, Jafar, Vatan Aksoy Tezer

 -- Blake Anderson <blakeanderson@utexas.edu>  Sun, 17 Jul 2022 22:00:00 -0000



=== debian/control ===
Source: ros-humble-moveit-servo
Section: misc
Priority: optional
Maintainer: Blake Anderson <blakeanderson@utexas.edu>
Build-Depends: debhelper (>= 9.0.0), ros-humble-ament-cmake, ros-humble-ament-cmake-gtest <!nocheck>, ros-humble-ament-lint-auto <!nocheck>, ros-humble-ament-lint-common <!nocheck>, ros-humble-control-msgs, ros-humble-control-toolbox, ros-humble-controller-manager <!nocheck>, ros-humble-geometry-msgs, ros-humble-moveit-common, ros-humble-moveit-core, ros-humble-moveit-msgs, ros-humble-moveit-resources-panda-moveit-config <!nocheck>, ros-humble-moveit-ros-planning-interface, ros-humble-pluginlib, ros-humble-ros-testing <!nocheck>, ros-humble-sensor-msgs, ros-humble-std-msgs, ros-humble-std-srvs, ros-humble-tf2-eigen, ros-humble-trajectory-msgs, ros-humble-ros-workspace
Homepage: https://ros-planning.github.io/moveit_tutorials
Standards-Version: 3.9.2

Package: ros-humble-moveit-servo
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-humble-control-msgs, ros-humble-control-toolbox, ros-humble-geometry-msgs, ros-humble-gripper-controllers, ros-humble-joint-state-broadcaster, ros-humble-joint-trajectory-controller, ros-humble-joy, ros-humble-launch-param-builder, ros-humble-moveit-common, ros-humble-moveit-configs-utils, ros-humble-moveit-core, ros-humble-moveit-msgs, ros-humble-moveit-ros-planning-interface, ros-humble-pluginlib, ros-humble-robot-state-publisher, ros-humble-sensor-msgs, ros-humble-std-msgs, ros-humble-std-srvs, ros-humble-tf2-eigen, ros-humble-tf2-ros, ros-humble-trajectory-msgs, ros-humble-ros-workspace
Description: Provides real-time manipulator Cartesian and joint servoing.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-moveit-servo//opt/ros/humble/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install
